<?php
/**
 * @version	$Id: 2_2_5.php 1362 2012-03-08 07:31:05Z cy $
 * @package	Mosets Tree
 * @copyright	(C) 2012 Mosets Consulting. All rights reserved.
 * @license	GNU General Public License
 * @author	Lee Cher Yeong <mtree@mosets.com>
 * @url		http://www.mosets.com/tree/
 */

defined('_JEXEC') or die('Restricted access');

class mUpgrade_2_2_5 extends mUpgrade {
	function upgrade() {
		$database =& JFactory::getDBO();

		// Update coredesc class code
		$database->setQuery('UPDATE #__mt_fieldtypes SET ft_class = "class mFieldType_coredesc extends mFieldType {\r\n	var $name = \'link_desc\';\r\n	function parseValue($value) {\r\n		$params[\'maxChars\'] = intval($this->getParam(\'maxChars\',3000));\r\n		$params[\'stripAllTagsBeforeSave\'] = $this->getParam(\'stripAllTagsBeforeSave\',0);\r\n		$params[\'allowedTags\'] = $this->getParam(\'allowedTags\',\'u,b,i,a,ul,li,pre,blockquote,strong,em\');\r\n		if($params[\'stripAllTagsBeforeSave\']) {\r\n			$value = $this->stripTags($value,$params[\'allowedTags\']);\r\n		}\r\n		if($params[\'maxChars\'] > 0) {\r\n			$value = JString::substr( $value, 0, $params[\'maxChars\']);\r\n		}\r\n		return $value;\r\n	}\r\n	function getInputHTML() {\r\n		global $mtconf;\r\n		\r\n		if( ($this->inBackEnd() AND $mtconf->get(\'use_wysiwyg_editor_in_admin\')) || (!$this->inBackEnd() AND $mtconf->get(\'use_wysiwyg_editor\')) ) {\r\n			$editor = &JFactory::getEditor();\r\n			$html = $editor->display( $this->getInputFieldName(1), $this->getValue() , \'100%\', \'250\', \'75\', \'25\', array(\'pagebreak\', \'readmore\') );\r\n		} else {\r\n			$html = \'<textarea class=\"inputbox\" name=\"\' . $this->getInputFieldName(1) . \'\" style=\"width:95%;height:\' . $this->getSize() . \'px\">\' . htmlspecialchars($this->getValue()) . \'</textarea>\';\r\n		}\r\n		return $html;\r\n	}\r\n	function getSearchHTML() {\r\n		return \'<input class=\"inputbox\" type=\"text\" name=\"\' . $this->getName() . \'\" size=\"30\" />\';\r\n	}\r\n	function getOutput($view=1) {\r\n		$params[\'parseUrl\'] = $this->getParam(\'parseUrl\',1);\r\n		$params[\'summaryChars\'] = $this->getParam(\'summaryChars\',255);\r\n		$params[\'stripSummaryTags\'] = $this->getParam(\'stripSummaryTags\',1);\r\n		$params[\'stripDetailsTags\'] = $this->getParam(\'stripDetailsTags\',1);\r\n		$params[\'parseMambots\'] = $this->getParam(\'parseMambots\',0);\r\n		$params[\'allowedTags\'] = $this->getParam(\'allowedTags\',\'u,b,i,a,ul,li,pre,blockquote,strong,em\');\r\n		$params[\'showReadMore\'] = $this->getParam(\'showReadMore\',0);\r\n		$params[\'whenReadMore\'] = $this->getParam(\'whenReadMore\',0);\r\n		$params[\'txtReadMore\'] = $this->getParam(\'txtReadMore\',JTEXT::_( \'Read More...\' ));\r\n		\r\n		$html = $this->getValue();\r\n		$output = \'\';\r\n		\r\n		// Details view\r\n		if($view == 1) {\r\n			global $mtconf;\r\n			$output = $html;\r\n			if($params[\'stripDetailsTags\']) {\r\n				$output = $this->stripTags($output,$params[\'allowedTags\']);\r\n			}\r\n			if($params[\'parseUrl\']) {\r\n				$regex = \'/http:\\\\/\\\\/(.*?)(\\\\s|$)/i\';\r\n				$output = preg_replace_callback( $regex, array($this,\'linkcreator\'), $output );\r\n			}\r\n			if (!$mtconf->get(\'use_wysiwyg_editor\') && $params[\'stripDetailsTags\'] && !in_array(\'br\',explode(\',\',$params[\'allowedTags\'])) && !in_array(\'p\',explode(\',\',$params[\'allowedTags\'])) ) {\r\n				$output = nl2br(trim($output));\r\n			}\r\n			if($params[\'parseMambots\']) {\r\n				$this->parseMambots($output);\r\n			}\r\n		// Summary view\r\n		} else {\r\n			$html = preg_replace(\'@{[\\\\/\\\\!]*?[^<>]*?}@si\', \'\', $html);\r\n			if($params[\'stripSummaryTags\']) {\r\n				$html = strip_tags( $html );\r\n			}\r\n			if($params[\'summaryChars\'] > 0) {\r\n				$trimmed_desc = trim(JString::substr($html,0,$params[\'summaryChars\']));\r\n			} else {\r\n				$trimmed_desc = \'\';\r\n			}\r\n			if($params[\'stripSummaryTags\']) {\r\n				$html = htmlspecialchars( $html );\r\n				$trimmed_desc = htmlspecialchars( $trimmed_desc );\r\n			}\r\n			if (JString::strlen($html) > $params[\'summaryChars\']) {\r\n				$output .= $trimmed_desc;\r\n				$output .= \' <b>...</b>\';\r\n			} else {\r\n				$output = $html;\r\n			}\r\n			if( $params[\'showReadMore\'] && ($params[\'whenReadMore\'] == 1 || ($params[\'whenReadMore\'] == 0 && JString::strlen($html) > $params[\'summaryChars\'])) ) {\r\n				if(!empty($trimmed_desc)) {\r\n					$output .= \'<br />\';\r\n				}\r\n				global $Itemid;\r\n				$output .= \' <a href=\"\' . JRoute::_(\'index.php?option=com_mtree&task=viewlink&link_id=\' . $this->getLinkId() . \'&Itemid=\'.$Itemid) . \'\" class=\"readon\">\' . $params[\'txtReadMore\'] . \'</a>\';\r\n			}\r\n		}\r\n		return $output;\r\n	}\r\n}"  WHERE field_type = "coredesc" LIMIT 1');
		$database->query();
		$this->printStatus( 'Updated description field type.' );
		
		$database->setQuery('DELETE FROM `#__mt_config` WHERE `varname` IN (\'gmaps_api_key\',\'map_control\')');
		$database->query();
		
		updateVersion(2,2,5);
		$this->updated = true;
		return true;
	}
}
?>